/*-
 * Copyright (C) 2009 Nokia
 * Heavily based on tumbler:
 * Copyright (c) 2009 Jannis Pohlmann <jannis@xfce.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef __GST_THUMB_FLAVOR_H__
#define __GST_THUMB_FLAVOR_H__

#include <glib-object.h>

G_BEGIN_DECLS

#define THUMBER_TYPE_FLAVOR            (thumber_flavor_get_type ())
#define THUMBER_FLAVOR(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), THUMBER_TYPE_FLAVOR, ThumberFlavor))
#define THUMBER_FLAVOR_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  THUMBER_TYPE_FLAVOR, ThumberFlavorClass))
#define THUMBER_IS_FLAVOR(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), THUMBER_TYPE_FLAVOR))
#define THUMBER_IS_FLAVOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  THUMBER_TYPE_FLAVOR)
#define THUMBER_FLAVOR_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  THUMBER_TYPE_FLAVOR, ThumberFlavorClass))

typedef struct _ThumberFlavorPrivate ThumberFlavorPrivate;
typedef struct _ThumberFlavorClass   ThumberFlavorClass;
typedef struct _ThumberFlavor        ThumberFlavor;

GType thumber_flavor_get_type                      (void) G_GNUC_CONST;

ThumberFlavor *thumber_flavor_new                  (const gchar            *name,
                                                    gint                    width,
                                                    gint                    height,
                                                    gint                    min_width,
                                                    gint                    min_height,
                                                    const gchar            *frame_selection,
						    const gchar            *rotation) G_GNUC_MALLOC G_GNUC_WARN_UNUSED_RESULT;
ThumberFlavor *thumber_flavor_new_normal           (void) G_GNUC_MALLOC G_GNUC_WARN_UNUSED_RESULT;
ThumberFlavor *thumber_flavor_new_large            (void) G_GNUC_MALLOC G_GNUC_WARN_UNUSED_RESULT;
const gchar   *thumber_flavor_get_name             (const ThumberFlavor    *flavor);
void           thumber_flavor_get_size             (const ThumberFlavor    *flavor,
                                                    gint                   *width,
                                                    gint                   *height,
                                                    gint                   *min_width,
                                                    gint                   *min_height);
const gchar   *thumber_flavor_get_frame_selection  (const ThumberFlavor    *flavor);
const gchar   *thumber_flavor_get_rotation         (const ThumberFlavor    *flavor);

G_END_DECLS

#endif /* !__GST_THUMB_FLAVOR_H__ */
